#ifndef SYGIMAP_MESSAGES_H
#define SYGIMAP_MESSAGES_H

//define IDs and consts

//map types

#define MAP_TIPO_NONE   0
#define MAP_TIPO_DXF    1  //vectorial
#define MAP_TIPO_RAS    2  //raster

  
//message IDs

#define SGI_CONNECT           700
#define SGI_DISCONNECT        701
#define SGI_DATA_OBJECT       702
#define SGI_DATA_MSG          703
#define SGI_DATA_POSITION     704
#define SGI_DATA_MAP          705

#define SGI_CONNECT_OK        800
#define SGI_DATA_OK           801
#define SGI_DATA_OBJECT_OK    802
#define SGI_DATA_OVERTAKE     803


//predefined object types:

//landmark
#define TYPE_LANDMARK          100

//basic  objects
#define TYPE_VEHICLE           101
#define TYPE_AMBULANCE         102
#define TYPE_BOMBER            103
#define TYPE_BUS               104
#define TYPE_TRUCK             105
#define TYPE_VAN               106
#define TYPE_WALKER            107
#define TYPE_PLANE             108
#define TYPE_SHIP              109
#define TYPE_TRAIN             110
#define TYPE_TRAM              111
#define TYPE_EMERGENCY         112


//user object types:
//ID > 200

//...

//...


//define message structs

struct struct1{
                  int idObjetc;
                  int typeObjetc;
                  int status;

                  bool isLandMark;
                  int distance;

                  char description[64]; 

                  char map[128];

                  char x[16];
                  char y[16];
                  char z[16];
                  char velocity[16];

                  int user1;
                  int user2;
                  int user3;

                  char user4[64];
                  char user5[128];
                  char user6[255];
}

typedef struct1 struct_DATA_OBJECT;


struct struct2{
                  int idObjetc;
                  int typeObjetc;
                  int status;

                  char x[16];
                  char y[16];
                  char z[16];
                  char velocity[16];
}

typedef struct2 struct_DATA_POSITION;
    

struct struct3{
                  int idObjetc;
                  int typeObjetc;
                  int status;
}

typedef struct3 struct_DATA_REPLY_OBJECT;


struct struct4{
                  int idTarget;
                  int typeTarget;

                  int idObjetc;
                  int typeObjetc;

                  char x[16];
                  char y[16];
                  char z[16];
                  char velocity[16];
}

typedef struct4 struct_DATA_OVERTAKE;


struct struct5{
                  char ip[16];
                  char msg[255];
}

typedef struct5 struct_DATA_MSG;


struct struct6{
                  char ip[16];
                  int tipo;
                  char map[255];
}

typedef struct6 struct_DATA_MAP;


struct struct7{
                  char ip[16];
                  char map[255];
}

typedef struct7 struct_DATA_CONNECT;


struct struct8{
                  int idHit;

                  int idObjetc;
                  int typeObjetc;
                  int status;

                  char distance[16];                  
}

typedef struct8 struct_DATA_REPLY_HIT;


#endif