unit sygimap_messages;

interface

uses Windows, Classes, SysUtils;

const

//define IDs and consts

//map types

  MAP_TIPO_NONE = 0;
  MAP_TIPO_DXF  = 1;  //vectorial
  MAP_TIPO_RAS  = 2;  //raster

//message IDs

  SGI_CONNECT           = 700;
  SGI_DISCONNECT        = 701;
  SGI_DATA_OBJECT       = 702;
  SGI_DATA_MSG          = 703;
  SGI_DATA_POSITION     = 704;
  SGI_DATA_MAP          = 705;

  SGI_CONNECT_OK        = 800;
  SGI_DATA_OK           = 801;
  SGI_DATA_OBJECT_OK    = 802;
  SGI_DATA_OVERTAKE     = 803;

//predefined object types:

//landmark
  TYPE_LANDMARK         = 100;

//basic  objects
  TYPE_VEHICLE          = 101;
  TYPE_AMBULANCE        = 102;
  TYPE_BOMBER           = 103;
  TYPE_BUS              = 104;
  TYPE_TRUCK            = 105;
  TYPE_VAN              = 106;
  TYPE_WALKER           = 107;
  TYPE_PLANE            = 108;
  TYPE_SHIP             = 109;
  TYPE_TRAIN            = 110;
  TYPE_TRAM             = 111;
  TYPE_EMERGENCY        = 112;


//user object types:
//ID > 200

//...

//...


//define message structs

  type

    struct_DATA_OBJECT = record

                  idObjetc: integer;
                  typeObjetc: integer;
                  status: integer;

                  isLandMark: boolean;
                  distance: integer;

                  description: string[64];

                  map: string[128];

                  x: string[16];
                  y: string[16];
                  z: string[16];
                  velocity: string[16];

                  user1: integer;
                  user2: integer;
                  user3: integer;

                  user4: string[64];
                  user5: string[128];
                  user6: string[255];
              end;

    struct_DATA_POSITION = record

                  idObjetc: integer;
                  typeObjetc: integer;
                  status: integer;

                  x: string[16];
                  y: string[16];
                  z: string[16];
                  velocity: string[16];
              end;

    struct_DATA_REPLY_OBJECT = record

                  idObjetc: integer;
                  typeObjetc: integer;

                  status: integer;
              end;

    struct_DATA_OVERTAKE = record

                  idTarget: integer;
                  typeTarget: integer;

                  idObjetc: integer;
                  typeObjetc: integer;

                  x: string[16];
                  y: string[16];
                  z: string[16];
                  velocity: string[16];
              end;

    struct_DATA_MSG = record

                  ip: string[16];
                  msg: string[255];
              end;

    struct_DATA_MAP = record

                  ip: string[16];
                  tipo: integer;
                  map: string[255];
              end;

    struct_DATA_CONNECT = record

                  ip: string[16];
                  map: string[255];
              end;

    struct_DATA_REPLY_HIT = record

                  idHit: integer;

                  idObjetc: integer;
                  typeObjetc: integer;
                  status: integer;

                  distance: string[16];
              end;


implementation

end.
